<?php
namespace wbb\system\event\listener;
use wcf\system\event\IEventListener;
use wcf\data\shoutbox\ShoutboxEntryFactory;
use wcf\system\WCF;

/**
 * Shoutbox board top listener for assigning
 * 
 * @author	Sonnenspeer
 * @copyright	2013 Sonnenspeer
 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>
 * @package	de.sonnenspeer.shoutbox
 */
class ShoutboxBoardTopListener implements IEventListener {
	/**
     * shoutbox factory
     */
    public $factory = null;
	
	/**
	 * status
	 */
	public $status = null;	
	
	/**
	 * @see	\wcf\system\event\IEventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName) {
		if(MODULE_SHOUTBOX) {
			$this->factory = new ShoutboxEntryFactory();
			$this->factory->init();
			
			// get status
			if (WCF::getUser()->userID) {
				$this->status = intval(WCF::getUser()->shoutboxBoxStatus);
			}
			else {
				if (($this->status = WCF::getSession()->getVar('shoutboxBoxStatus')) === null) {
					$this->status = 1;
				}
			}
			
			// assign variables
			WCF::getTPL()->assign(array(
				'smileys' => $this->factory->getSmileys(),
				'shoutboxEntries' => $this->factory->getEntries(),
				'shoutboxBoxStatus' => $this->status,
				'username' => WCF::getSession()->username
			));
		}
	}
}
